import { APIGatewayProxyEvent, APIGatewayProxyResult, Context } from 'aws-lambda';
import { RouterMapType } from '../types/TRouter';
import BaseRouter from './BaseRouter';
export type controllerResultType = APIGatewayProxyResult;
export type HandlerResultType = Promise<controllerResultType>;
export type HandlerType = (event: APIGatewayProxyEvent, context: Context) => HandlerResultType;
export default class AwsSamRouter extends BaseRouter<HandlerType> {
    _lookup(map: RouterMapType<HandlerType>, receivedMethod: string, receivedPath: string): HandlerType;
    lookup(receivedMethod: string, receivedPath: string): Promise<HandlerType>;
    expose(): HandlerType;
}
