"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EVENTS = void 0;
var http_1 = require("../errors/http");
var EVENTS;
(function (EVENTS) {
    EVENTS[EVENTS["ROUTE_PROCESSED"] = 0] = "ROUTE_PROCESSED";
    EVENTS[EVENTS["ALL_ROUTES_PROCESSED"] = 1] = "ALL_ROUTES_PROCESSED";
})(EVENTS = exports.EVENTS || (exports.EVENTS = {}));
var BaseRouter = /** @class */ (function () {
    function BaseRouter() {
        this.map = {};
        this.allRoutesLoaded = false;
        this.__isExposed = false;
        this.__totalOfRoutes = 0;
        this.__routesProccesed = 0;
    }
    /**
     * defined method to lookup for a resource controller. MUST be implemented
     * @param receivedMethod
     * @param receivedPath
     */
    BaseRouter.prototype.lookup = function (receivedMethod, receivedPath) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw http_1.NotImplementedYet;
            });
        });
    };
    BaseRouter.prototype.addEventListener = function (listenerHandler) {
        this.__eventListener = listenerHandler;
    };
    BaseRouter.prototype.emit = function (type, data) {
        if (typeof this.__eventListener === 'function') {
            this.__eventListener(type, data);
        }
    };
    BaseRouter.prototype.emitPartial = function (map) {
        if (this.__routesProccesed === this.__totalOfRoutes && this.__isExposed) {
            this.allRoutesLoaded = true;
            this.emit(EVENTS.ALL_ROUTES_PROCESSED, this.map);
            return;
        }
        this.emit(EVENTS.ROUTE_PROCESSED, map);
    };
    BaseRouter.prototype.lookupInCustomRouter = function (eventMapLookupController) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var _a;
                        // map of event handler
                        var eventMapHandler = (_a = {},
                            _a[EVENTS.ALL_ROUTES_PROCESSED] = function (data) {
                                var customControllerLookup = eventMapLookupController[EVENTS.ALL_ROUTES_PROCESSED];
                                if (customControllerLookup)
                                    resolve(customControllerLookup(data));
                            },
                            _a);
                        // function that listen to changes in the router
                        var eventHandler = function (event, data) {
                            try {
                                // take the proper handler from event
                                var eventTypeHandler = eventMapHandler[event];
                                // if it's configured the call it
                                if (eventTypeHandler)
                                    eventTypeHandler(data);
                            }
                            catch (e) {
                                reject(e);
                            }
                        };
                        // If router is 100% loaded then get the event handler when the router has been finished
                        if (_this.allRoutesLoaded) {
                            var eventHandler_1 = eventMapHandler[EVENTS.ALL_ROUTES_PROCESSED];
                            eventHandler_1(_this.map);
                            return;
                        }
                        // subscribe
                        _this.addEventListener(eventHandler);
                    })];
            });
        });
    };
    BaseRouter.prototype.getMapKey = function (route, separator) {
        if (separator === void 0) { separator = BaseRouter.separator; }
        return "".concat(route.method.toLowerCase()).concat(separator).concat(route.path);
    };
    BaseRouter.prototype.useController = function (route, overrides) {
        var _this = this;
        if (overrides === void 0) { overrides = {}; }
        setTimeout(function () {
            var fullRoute = __assign(__assign({}, route), overrides);
            var mapKey = _this.getMapKey(__assign({}, fullRoute));
            _this.map[mapKey] = fullRoute.controller;
            _this.__routesProccesed++;
            _this.emitPartial(_this.map);
        });
    };
    BaseRouter.prototype.useAll = function (routes, overrides) {
        var _this = this;
        if (overrides === void 0) { overrides = {}; }
        this.__totalOfRoutes += routes.length;
        routes.map(function (route) { return _this.useController(route, overrides); });
    };
    /**
     * Overloaded method.
     *
     * If args is type of [string,RouterController<T>] add a single controller for that path. Usually you call it when using the util createController.
     * if args is type of [RouterController<T>[]] add a bulk of paths.
     * @param args All arguments.
     */
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    BaseRouter.prototype.use = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            var path = args[0], routeOrRoutes = args[1];
            var arrayOfRoutes = Array.isArray(routeOrRoutes) ? routeOrRoutes : [routeOrRoutes];
            this.useAll(arrayOfRoutes, { path: path });
        }
        else if (Array.isArray(args[0])) {
            this.useAll(args[0]);
        }
        else {
            this.useAll([args[0]]);
        }
    };
    BaseRouter.prototype.delete = function (awsPath) {
        delete this.map[awsPath];
    };
    BaseRouter.prototype.expose = function () {
        this.__isExposed = true;
    };
    BaseRouter.errorToHttpError = function (e) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var error = http_1.ServerError;
        if ((0, http_1.isHttpError)(e)) {
            error = e;
        }
        var statusCode = error.statusCode, message = error.message;
        return { statusCode: statusCode, body: message };
    };
    BaseRouter.separator = ':::';
    return BaseRouter;
}());
exports.default = BaseRouter;
